import pickle
import sklearn
#print(sklearn.__version__)
import sklearn
import sklearn.gaussian_process
from sklearn.gaussian_process import GaussianProcessRegressor
from sklearn.gaussian_process.kernels import RBF, ConstantKernel as C
from sklearn.gaussian_process.kernels import DotProduct, WhiteKernel 


import pandas as pd
import numpy as np

df=pd.read_excel('train.xls')
#C:\articles\to_upload\Vizcarra
#print(df)
X_raw = (df["S2_NDVI"].to_numpy())
#print(X_raw.shape)
X=np.reshape(X_raw,(X_raw.shape[0], 1))
y=(df["MEAN_drone"].to_numpy()).ravel()

#y=np.atleast_2d(y)

#print(X.shape,y.shape)

X_train= X[500:1500]
Y_train= y[500:1500]

X_test=X[1500:2000]
#Y_test=y[2955:3940]
print(X_train.shape, Y_train.shape, X_test.shape)

# Instantiate a Gaussian Process model
#kernel = C(1.0, (1e-3, 1e3)) * RBF(10, (1e-2, 1e2))
kernel = DotProduct() + WhiteKernel()
gp_model = GaussianProcessRegressor(kernel=kernel, n_restarts_optimizer=9)

# Fit to data using Maximum Likelihood Estimation of the parameters
gp_model.fit(X_train, Y_train)



def predict_correct_S2_NDVI(S2_NDVI):
    
    S2_NDVI=np.array(S2_NDVI).reshape(1, -1) # for a single sample
	
    #with open('gp_model.pkl', 'rb') as f:
        #gp_model = pickle.load(f)
    prediction = gp_model.predict(S2_NDVI)
    #prediction = S2_NDVI +1
    
    prediction,sigma = gp_model.predict(S2_NDVI, return_std=True)
     
    print(prediction)
    return prediction